#!/usr/bin/perl

use CGI;
use LWP::Simple;

my $cgi = new CGI();

print "Content-type: text/java\n\n";
print jd2j( $cgi->param('url') );

sub jd2j {
	if ( $_[ 0 ] gt "" && $_[0] gt 'http://' ) {
		$page = get( $_[ 0 ] );
		$_[ 0 ] =~ /\/([^\.\/]*)\.html$/i;
		$shortName = $fileName = $1 . ".java";
		$shortName =~ s/\.java//g;
		$makeDef = 0;
	} else {
		return "";
	}

	$tab = "	";
	$page =~ s/\r//g;
	$page =~ s/java\.lang\.//gi;
	if ( $page =~ s/java\.util\.//gi ) {
		push ( @imports, "util.*" );
	}

	( $junk, $page ) = split ( /<!-- ======== START OF CLASS DATA ======== -->/, $page );
	if ( $page =~ /<!-- ======== NESTED CLASS SUMMARY ======== -->/ ) {
		( $tData, $page ) = split ( /<!-- ======== NESTED CLASS SUMMARY ======== -->/, $page );
	} else {
		( $tData, $page ) = split ( /<!-- ======== INNER CLASS SUMMARY ======== -->/, $page );
	}
	( $junk, $page ) = split ( /<!-- ============ FIELD DETAIL =========== -->/, $page );
	( $page, $junk ) = split ( /<!-- ========= END OF CLASS DATA ========= -->/, $page );
	( $fData, $page ) = split ( /<!-- ========= CONSTRUCTOR DETAIL ======== -->/, $page );
	( $cData, $mData ) = split ( /<!-- ============ METHOD DETAIL ========== -->/, $page );

	#open ( FILE, ">" . $fileName );
	$return = "";

	# Process file information
	if ( $tData =~ /Author:(<[^>]*>)?([^\n]*)\n/is ) {
		$author = $2;
		$author =~ s/<[^>]*>//g;
	} else {
		$author = "Your Name";
	}
	( $junk, $tData ) = split( /<hr>/i, $tData );
	( $tData, $junk ) = split( /<p>\n<dl>/i, $tData );
	$tData =~ s/^\n*<dl>\n*//i;
	( $info, $desc ) = split( /<\/dl>\n/i, $tData );
	$info =~ s/^<dt>//gi;
	$info =~ s/<dt>/ /ig;
	$info =~ s/<[^>]*>//g;
	$info =~ s/ extends Object//ig;
	if ( $info =~ /\n/ ) {
		$info =~ s/^\n*//g;
		( $junk, $junk, $info, @parts ) = split( /\n/, $info );
		$desc = join( "\n", @parts );
	}
	$desc =~ s/\n\n+/\n/g;
	if ( $desc !~ /^\n/ ) {
		$desc = " * " . $desc;
	}
	$desc =~ s/<p>\n*//gi;
	$desc =~ s/\n/\n * /g;
	$desc =~ s/^\n*//g;

	$return .= qq~/*\n * $fileName\n *\n * Version:\n *	 \$Id\$\n *\n * Revisions:\n *	 \$Log\$\n */\n~;

	foreach $import ( @imports ) {
		$return .= "import java.$import\;\n";
	}
	
	if ( $desc eq "" ) {
		$desc = " * ENTER YOUR DESCRIPTION HERE";
	}
	if ( $info eq "" ) {
		$info = "public class $shortName";
		$makeDef = 1;
	}
	
	$return .= qq~\n/**\n$desc\n *\n *	\@author $author\n */\n$info {\n\n~;

	# Process Field Items
	@items = split( /<hr>/i, $fData );
	foreach $item ( @items ) {
		( $junk, $info ) = split( /<pre>/i, $item );
		( $info, $junk ) = split( /<p>\n<dl>/i, $info );
		$info =~ s/<[^>]*>//g;
		$info =~ s/\s\s+/\n/g;
		( $junk, $code, $desc, @etc ) = split ( /\n/, $info );
		if ( $code gt "" ) {
			$return .= "$tab// " . $desc . "\n";
			$return .= "$tab" . $code . ";\n";
		}
	}
	if ( $code ) {
		$return .= "\n";
	}

	if ( $makeDef ) {
		$return .= "$tab/**\n$tab * Default Constructor Description\n$tab *\n$tab */\n$tab";
		$return .= "public $shortName(  ) {\n$tab$tab\n$tab}\n\n";
	}

	# Process Contructors
	@items = split( /<hr>/i, $cData );
	foreach $item ( @items ) {
		( $junk, $info ) = split( /<pre>/i, $item );
		( $info, $data ) = split( /<p>\n<dt>/i, $info );
		#if ( $info =~ /<p>\n<dd>/i ) {
		#	( $info, $data ) = split( /<p>\n<dd>/i, $info );
		#} else {
		#	( $info, $data ) = split( /<dd><dl>/i, $info );
		#}
		$info =~ s/<\/pre>/***/i;
		$info =~ s/<[^>]*>//g;
		$info =~ s/\s\s+/\n/g;
		$info =~ s/^\n*//;
		$info =~ s/\n*$//;
		( $code, $desc ) = split( /\*\*\*/, $info );
		$code =~ s/\&nbsp;/ /g;
		$code =~ s/\n/ /g;
		$code =~ s/\(/\( /;
		$code =~ s/\)/ \)/;
		$desc =~ s/\n/\n\t * /g;
		$desc =~ s/^\n//g;
		$data =~ s/\n*<\/?d[dl]>\n*//gi;
		if ( $desc eq "" ) {
			$desc = "$tab *";
		}
		if ( $code gt "" ) {
			$return .= qq~$tab/**\n$desc\n$tab *~;

			#$return .= "**$data\**";
			@parts = split ( /<dt>/i, $data );
			foreach $part ( @parts ) {
				$part =~ s/\s\s+/ /g;
				$part =~ s/\n/ /g;
				#$return .= "##$part\##";
				$part =~ /<b>([a-z]+):<\/b>(.*)/i;
				$name = $1;
				$partData = $2;

				if ( $name eq "Parameters" ) {
					$name = "param";
				} elsif ( $name eq "Throws" ) {
					$name = "exception";
				} elsif ( $name eq "Returns" ) {
					$name = "return";
				} else {
					$name = lc ( $name );
				}
				$partData =~ s/<code>/\n/ig;
				$partData =~ s/<\/code>/\t/ig;
				$partData =~ s/^\n//g;
				$partData =~ s/<[^>]*>//g;

				@pdatas = split ( /\n/i, $partData );
				foreach $pdata ( @pdatas ) {
					$pdata =~ s/ - //g;
					( $object, $description ) = split ( /\t/, $pdata );
					$return .= "\n$tab * \@$name $object $description";
				}
			}

			$return .= qq~\n$tab */\n$tab$code {\n$tab$tab\n$tab}\n\n~;
			#$return .= qq~$tab/**\n$desc\n$tab *\n$tab */\n$tab$code {\n$tab$tab\n$tab}\n\n~;
		}
	}

	# Process Methods
	@items = split( /<hr>/i, $mData );
	foreach $item ( @items ) {
		( $junk, $info ) = split( /<pre>/i, $item );	
		if ( $info =~ /<p>\n<dd>/i ) {
			( $info, $data ) = split( /<p>\n<dd>/i, $info );
		} else {
			( $info, $data ) = split( /<dd><dl>/i, $info );
		}
		$info =~ s/<\/pre>/***/i;
		$info =~ s/<[^>]*>//g;
		$info =~ s/\s\s+/\n/g;
		$info =~ s/^\n*//;
		$info =~ s/\n*$//;
		( $code, $desc ) = split( /\*\*\*/, $info );
		$code =~ s/\&nbsp;/ /g;
		$code =~ s/\n/ /g;
		$code =~ s/\(/\( /;
		$code =~ s/\)/ \)/;
		$desc =~ s/\n/\n$tab * /g;
		$desc =~ s/^\n//g;
		$data =~ s/\n*<\/?d[dl]>\n*//gi;
	
		if ( $code gt "" ) {
			$return .= qq~$tab/**\n$desc\n$tab *~;

			#$return .= "**$data\**";
			@parts = split ( /<dt>/i, $data );
			foreach $part ( @parts ) {
				$part =~ s/\s\s+/ /g;
				$part =~ s/\n/ /g;
				#$return .= "##$part\##";
				$part =~ /<b>([a-z]+):<\/b>(.*)/i;
				$name = $1;
				$partData = $2;

				if ( $name eq "Parameters" ) {
					$name = "param";
				} elsif ( $name eq "Throws" ) {
					$name = "exception";
				} elsif ( $name eq "Returns" ) {
					$name = "return";
				} else {
					$name = lc ( $name );
				}
				$partData =~ s/<code>/\n/ig;
				$partData =~ s/<\/code>/\t/ig;
				$partData =~ s/^\n//g;
				$partData =~ s/<[^>]*>//g;

				@pdatas = split ( /\n/i, $partData );
				foreach $pdata ( @pdatas ) {
					$pdata =~ s/ - //g;
					( $object, $description ) = split ( /\t/, $pdata );
					$return .= "\n$tab * \@$name $object $description";
				}
			}

			$return .= qq~\n$tab */\n$tab$code {\n$tab$tab\n$tab}\n\n~;
		}
	}

	$return .= "}// $shortName";
	return $return;
}
1;
